Magellan Linux

Contents of /trunk/mage/usr/lib/mage/smage2.functions.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1795 - (show annotations) (download) (as text)
Wed Apr 11 21:27:09 2012 UTC (12 years ago) by niro
File MIME type: application/x-sh
File size: 30071 byte(s)
-show full path to file which gets unpacked
1 #!/bin/bash
2 # smage2 releated functions
3 # $Id$
4
5 # sources the smage file and uses state from distribution file if exist
6 # may helpful for repository support later on
7 smagesource()
8 {
9 local file="$1"
10 local localstate
11 local distfilestate
12 local mytag
13
14 source ${file}
15
16 # if PCAT was not set and PCATEGORIE was found
17 # inform the user and use PCATEGORIE as PCAT
18 if [[ -z ${PCAT} ]]
19 then
20 if [[ -n ${PCATEGORIE} ]]
21 then
22 PCAT="${PCATEGORIE}"
23 unset PCATEGORIE
24 # print a warning
25 echo -e "${COLYELLOW}Warning: 'PCATEGORIE' is deprecated and gets removed in the future.${COLDEFAULT}"
26 echo -e "${COLYELLOW} Please modify this smage2 script to use the 'PCAT' variable.${COLDEFAULT}"
27 echo
28 else
29 die "Neither PCAT nor PCATEGORIE are defined!"
30 fi
31 fi
32
33 [[ -n ${STATE} ]] && localstate="${STATE}"
34 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
35
36 if [ -f ${SMAGESCRIPTSDIR}/distribution ]
37 then
38 source ${SMAGESCRIPTSDIR}/distribution
39 [[ -n ${STATE} ]] && distfilestate="${STATE}"
40 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
41 fi
42 # now switch state and export it but do not overide any local states
43 if [[ ! -z ${localstate} ]]
44 then
45 STATE="${localstate}"
46 else
47 STATE="${distfilestate}"
48 fi
49
50 if mqueryfeature "pkgdistrotag"
51 then
52 # if DISTROTAG was not defined globally
53 # or in distribution file then deactivate this feature!
54 # at this point $mytag must have the distrotag
55 if [[ -z ${mytag} ]]
56 then
57 FVERBOSE=off msetfeature "!pkgdistrotag"
58 unset DISTROTAG
59 echo -e "${COLRED}Requested 'pkgdistrotag' but no \$DISTROTAG found!${COLDEFAULT}"
60 echo -e "${COLRED}Disabled the feature for pkgbuild sanity!${COLDEFAULT}"
61 else
62 # now switch state and export it but do not overide any local states
63 export DISTROTAG="${mytag}"
64 fi
65 else
66 unset DISTROTAG
67 fi
68 }
69
70 print_distrotag()
71 {
72 if FVERBOSE=off mqueryfeature "pkgdistrotag"
73 then
74 if [[ ! -z ${DISTROTAG} ]]
75 then
76 # add a point as prefix
77 echo ".${DISTROTAG}"
78 fi
79 fi
80 }
81
82 showversion()
83 {
84 echo -en "Magellan Source Install v${SMAGEVERSION} "
85 echo -e "-- Niels Rogalla (niro@magellan-linux.de)"
86 }
87
88 die()
89 {
90 xtitleclean
91 echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}
92 echo "SMAGE failed: $@"
93 exit 1
94 }
95
96 die_pipestatus()
97 {
98 # the status change if we do any parameter declarations!!
99 # dont do this anymore, keep this in mind!
100 #
101 # local pos="$1"
102 # local comment="$2"
103 #
104 # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
105 #
106 [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
107 }
108
109 xtitle()
110 {
111 if [[ ${TERM} = xterm ]]
112 then
113 echo -ne "\033]0;[sMage: $@]\007"
114 fi
115 return 0
116 }
117
118 xtitleclean()
119 {
120 if [[ ${TERM} = xterm ]]
121 then
122 echo -ne "\033]0;\007"
123 fi
124 return 0
125 }
126
127 syncsmage2()
128 {
129 xtitle "Updating smage2-script tree ..."
130 local i
131 for i in ${SMAGE2RSYNC}
132 do
133 rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}
134 if [[ $? = 0 ]]
135 then
136 break
137 else
138 continue
139 fi
140 done
141
142 # clean up backup files (foo~)
143 find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'
144
145 xtitleclean
146 }
147
148 # $1 filename
149 get_db_md5_sum()
150 {
151 local DB_FILE
152 local MD5_FILE
153 local i
154
155 DB_ENTRY="$(basename $1)"
156 MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"
157
158 i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"
159
160 echo "${i}"
161 }
162
163 download_sources()
164 {
165 [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
166
167 local count=${#SRC_URI[*]}
168 local uri
169 local subdir
170 local outputdir
171 local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
172 local fetching
173 local i
174
175 # check if FETCHING is needed
176 if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
177 then
178 # md5's ok, no fetching needed
179 fetching=false
180 else
181 fetching=true
182 fi
183
184 if [[ ${fetching} = true ]]
185 then
186 for ((i=0; i < count; i++))
187 do
188 # url to file
189 uri="${SRC_URI[${i}]%%' '*}"
190
191 # subdir in sources dir; the my_SRCI_URI file goes to there
192 subdir="${SRC_URI[${i}]##*' '}"
193
194 # if $subdir is not equal with $uri then an other dir is used
195 if [[ ${uri} != ${subdir} ]]
196 then
197 outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
198 else
199 outputdir="${SOURCEDIR}/${PNAME}"
200 fi
201
202 echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
203 # always use verbose mode for source downloads
204 FVERBOSE=off msetfeature "verbose"
205 # do not die here, mchecksum catches download errors
206 mdownload --uri "${uri}" --dir "${outputdir}"
207
208 # unset them to be sure
209 unset uri
210 unset subdir
211 unset outputdir
212 done
213
214 # recheck md5 sums after download
215 echo
216 echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
217 mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
218 echo
219 else
220 echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
221 fi
222
223 # not needed anymore
224 unset SRC_URI
225 }
226
227 # dummy function, used if that does not exist in smage file
228 src_prepare()
229 {
230 echo "no src_prepare defined; doing nothing ..."
231 return 0
232 }
233
234 # dummy function, used if that does not exist in smage file
235 src_compile()
236 {
237 echo "no src_compile defined; doing nothing ..."
238 return 0
239 }
240
241 # dummy function, used if that does not exist in smage file
242 src_check()
243 {
244 echo "no src_check defined; doing nothing ..."
245 return 0
246 }
247
248 # dummy function, used if that does not exist in smage file
249 src_install()
250 {
251 echo "no src_install defined; doing nothing ..."
252 return 0
253 }
254
255 mlibdir()
256 {
257 local libdir=lib
258 [[ ${ARCH} = x86_64 ]] && libdir=lib64
259
260 echo "${libdir}"
261 }
262
263 mconfigure()
264 {
265 local myopts
266 if [[ ! -z ${CTARGET} ]]
267 then
268 myopts+=" --target=${CTARGET}"
269 fi
270
271 if [ -x ./configure ]
272 then
273 # if requested disable-static
274 if [[ ! -z $(./configure --help | grep -- '--.*able-static') ]]
275 then
276 if mqueryfeature '!static'
277 then
278 myopts+=" --disable-static"
279 else
280 myopts+=" --enable-static"
281 fi
282 fi
283
284 # always enable shared by default but not for waf configure
285 if [[ ! -z $(./configure --help | grep -- '--.*able-shared') ]] &&
286 [[ -z $(./configure --version | grep waf) ]]
287 then
288 myopts+=" --enable-shared"
289 fi
290
291 ./configure \
292 --prefix=/usr \
293 --host=${CHOST} \
294 --build=${CHOST} \
295 --mandir=/usr/share/man \
296 --infodir=/usr/share/info \
297 --datadir=/usr/share \
298 --sysconfdir=/etc \
299 --localstatedir=/var/lib \
300 --libdir=/usr/$(mlibdir) \
301 ${myopts} \
302 "$@" || die "mconfigure failed"
303 else
304 echo "configure is not an executable ..."
305 exit 1
306 fi
307 }
308
309 minstall()
310 {
311 if [ -f ./[mM]akefile -o -f ./GNUmakefile ]
312 then
313 make prefix=${BINDIR}/usr \
314 datadir=${BINDIR}/usr/share \
315 infodir=${BINDIR}/usr/share/info \
316 localstatedir=${BINDIR}/var/lib \
317 mandir=${BINDIR}/usr/share/man \
318 sysconfdir=${BINDIR}/etc \
319 libdir=${BINDIR}/usr/$(mlibdir) \
320 "$@" install || die "minstall failed"
321 else
322 die "no Makefile found"
323 fi
324 }
325
326 mmake()
327 {
328 make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"
329 }
330
331 munpack()
332 {
333 local SRCFILE
334 local IFTAR
335 local DEST
336
337 SRCFILE=$1
338
339 if [[ -z $2 ]]
340 then
341 DEST=${BUILDDIR}
342 else
343 DEST=$2
344 fi
345
346 echo -e "${COLBLUE}>>>${COLGREEN} Unpacking ${SOURCEDIR}/${PNAME}/${SRCFILE}${COLDEFAULT}"
347
348 [[ ! -d ${DEST} ]] && install -d ${DEST}
349
350 case "${SRCFILE##*.}" in
351 bz2)
352 IFTAR="$(basename $SRCFILE .bz2)"
353 IFTAR="${IFTAR##*.}"
354 if [[ ${IFTAR} = tar ]]
355 then
356 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
357 else
358 pushd ${DEST} > /dev/null
359 bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
360 popd > /dev/null
361 fi
362 ;;
363 gz)
364 IFTAR="$(basename $SRCFILE .gz)"
365 IFTAR="${IFTAR##*.}"
366 if [[ ${IFTAR} = tar ]]
367 then
368 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
369 else
370 pushd ${DEST} > /dev/null
371 zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
372 popd > /dev/null
373 fi
374 ;;
375 xz)
376 IFTAR="$(basename $SRCFILE .xz)"
377 IFTAR="${IFTAR##*.}"
378 if [[ ${IFTAR} = tar ]]
379 then
380 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
381 else
382 pushd ${DEST} > /dev/null
383 xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
384 popd > /dev/null
385 fi
386 ;;
387 tbz2|mpks|mpk)
388 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
389 ;;
390 tgz)
391 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
392 ;;
393 txz|mpkzs|mpkz)
394 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
395 ;;
396 rar)
397 unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST} || die ".rar unpack failed."
398 ;;
399 zip|xpi|jar)
400 unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
401 ;;
402 rpm)
403 pushd ${DEST} > /dev/null
404 rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
405 tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
406 if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
407 then
408 rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
409 fi
410 ;;
411 *)
412 die "munpack failed"
413 ;;
414 esac
415 }
416
417 mpatch()
418 {
419 local PATCHOPTS
420 local PATCHFILE
421 local i
422
423 PATCHOPTS=$1
424 PATCHFILE=$2
425
426 if [[ -z $2 ]]
427 then
428 PATCHFILE=$1
429
430 ## patch level auto-detection, get patch level
431 for ((i=0; i < 10; i++))
432 do
433 patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null
434 if [[ $? = 0 ]]
435 then
436 PATCHOPTS="-Np${i}"
437 break
438 fi
439 done
440 fi
441
442 echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"
443 patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}
444 }
445
446 mlibtoolize()
447 {
448 local opts="$@"
449 [[ -z ${opts} ]] && opts="--verbose --install --force"
450
451 libtoolize ${opts} || die "running: mlibtoolize ${opts}"
452 }
453
454 mautoreconf()
455 {
456 local opts="$@"
457 [[ -z ${opts} ]] && opts="--verbose --install --force"
458
459 autoreconf ${opts} || die "running: mautoreconf ${opts}"
460 }
461
462 minstalldocs()
463 {
464 local docfiles
465 local doc
466 docfiles="$@"
467
468 if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
469 then
470 install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
471 fi
472
473 for doc in ${docfiles}
474 do
475 if [ -f ${doc} ]
476 then
477 if mqueryfeature "compressdoc"
478 then
479 cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "gzipping +installing ${doc}."
480 chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "fixing permissions of ${doc}."
481 else
482 install -m 0644 ${doc} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
483 fi
484 fi
485 done
486 }
487
488 mstriplibs()
489 {
490 local stripdir="$@"
491
492 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
493 [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
494 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
495 }
496
497 mstripbins()
498 {
499 local stripdir="$@"
500
501 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
502 [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
503 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
504 }
505
506 mstripstatic()
507 {
508 local stripdir="$@"
509
510 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
511 [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
512 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
513 }
514
515 mstriplibtoolarchive()
516 {
517 local stripdir="$@"
518
519 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
520 find ${stripdir} ! -type d -name \*.la | xargs --no-run-if-empty file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
521 }
522
523 mpurgetargets()
524 {
525 local stripdir="$@"
526 local target
527
528 [[ -z ${stripdir} ]] && stripdir=${BINDIR}
529 # nothing to do in this case
530 [[ -z ${PURGE_TARGETS[*]} ]] && return
531
532 for target in ${PURGE_TARGETS[*]}
533 do
534 # check if target is a regex pattern without any slashes
535 if [[ ${target} = ${target//\/} ]]
536 then
537 find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
538 else
539 rm -f -- ${target} 2> /dev/null
540 fi
541 done
542 }
543
544 mcompressdocs()
545 {
546 local bindir="$@"
547
548 if [ -d ${bindir}/usr/share/man ]
549 then
550 echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
551 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
552 fi
553
554 if [ -d ${bindir}/usr/share/info ]
555 then
556 echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
557 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
558 fi
559 }
560
561 sminclude()
562 {
563 local i
564
565 if [[ -n "$@" ]]
566 then
567 for i in $@
568 do
569 echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"
570 source ${SMAGESCRIPTSDIR}/include/${i}.sminc
571 done
572 echo
573 fi
574 }
575
576 march()
577 {
578 local retval
579
580 if [[ ! -z ${ARCH} ]]
581 then
582 echo "${ARCH}"
583 retval=0
584 else
585 retval=1
586 fi
587
588 return "${retval}"
589 }
590
591 marchsrcfile()
592 {
593 local retval
594 if [[ ! -z $(eval echo \$SRCFILE_${ARCH/i*86/x86}) ]]
595 then
596 eval echo \$SRCFILE_${ARCH/i*86/x86} | tr ';' '\n'
597 retval=0
598 else
599 retval=1
600 fi
601
602 return "${retval}"
603 }
604
605 marchsrcdir()
606 {
607 local retval
608 if [[ ! -z $(eval echo \$SRCDIR_${ARCH/i*86/x86}) ]]
609 then
610 eval echo \$SRCDIR_${ARCH/i*86/x86} | tr ';' '\n'
611 retval=0
612 else
613 retval=1
614 fi
615
616 return "${retval}"
617 }
618
619 marchdepend()
620 {
621 local retval
622
623 if [[ ! -z $(eval echo \$DEPEND_${ARCH/i*86/x86}) ]]
624 then
625 echo "\$(eval echo \\\$DEPEND_\${ARCH/i*86/x86} | tr ';' '\n')"
626 retval=0
627 else
628 retval=1
629 fi
630
631 return "${retval}"
632 }
633
634 marchsdepend()
635 {
636 local retval
637 if [[ ! -z $(eval echo \$SDEPEND_${ARCH/i*86/x86}) ]]
638 then
639 echo "\$(eval echo \\\$SDEPEND_\${ARCH/i*86/x86} | tr ';' '\n')"
640 retval=0
641 else
642 retval=1
643 fi
644
645 return "${retval}"
646 }
647
648 setup_distcc_environment()
649 {
650 if [ -x /usr/bin/distcc ]
651 then
652 echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"
653 export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"
654
655 export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"
656
657 # creating distcc tempdir
658 install -o distcc -g daemon -d ${DISTCC_DIR}
659 chmod 1777 ${DISTCC_DIR}
660 fi
661 }
662
663 setup_ccache_environment()
664 {
665 if [ -x /usr/bin/ccache ]
666 then
667 echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
668 export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
669 fi
670 }
671
672 # fixes given dependencies to match a MAGE_TARGET
673 # fix_mage_deps -target s/depend # <-- note -target !
674 fix_mage_deps()
675 {
676 local target="$1"
677 local depend="$2"
678 local NDEPEND
679 local sym dep cat pver pname
680
681 # deps and provides are special
682 # they must be fixed to match the target
683
684 # run this only if target and depend is not empty
685 if [ -n "${target}" ] && [ -n "${depend}" ]
686 then
687 # fix DEPEND
688 while read sym dep
689 do
690 # ignore empty lines
691 [[ -z ${dep} ]] && continue
692
693 cat="$(dirname ${dep})"
694 # change if not virtual
695 if [[ ${cat} = virtual ]]
696 then
697 pname="$(basename ${dep})"
698 else
699 # fix pver to target-pver
700 # to get pname-target-pver
701
702 # doing it backwards !
703 pver="${dep##*-}"
704 # full pver
705 pname="$(basename ${dep/-${pver}/})${target}-${pver}"
706 fi
707
708 # do not add empty lines
709 if [ -z "${NDEPEND}" ]
710 then
711 NDEPEND="${sym} ${cat}/${pname}"
712 else
713 NDEPEND="${NDEPEND}
714 ${sym} ${cat}/${pname}"
715 fi
716
717 unset cat pname pver
718 done << EOF
719 ${depend}
720 EOF
721 # set NDEPEND to DEPEND
722 depend="${NDEPEND}"
723 fi
724
725 echo "${depend}"
726 }
727
728 # build_mage_script(): helper functions for regen_mage_tree()
729 # generates an mage file with given information in smage file
730 # needs at least:
731 # PNAME name of pkg
732 # PVER version
733 # PBUILD revision
734 # PCAT category of the pkg
735 # PCATEGORIE category of the pkg (deprecated, use PCAT!)
736 # STATE state of pkg stable|unstable|old
737 # DESCRIPTION a short description (opt)
738 # HOMEPAGE homepage (opt)
739 # LICENSE license information of the pkg (opt)
740 # DEPEND runtime dependencies (opt)
741 # SDEPEND adds needed deps to build the pkg (opt)
742 # PROVIDE provides a virtual (opt)
743 #
744 # special tags:
745 # PKGTYPE type of pkg
746 # INHERITS which functions get included
747 # SPECIAL_FUNCTIONS special functions which should also be added
748 # warning: they get killed before the build starts !
749 # SPLIT_PACKAGES names of all subpackages which are splitted from parent
750 # SPLIT_PACKAGE_BASE base package name for splitpackages
751 # (only in the resulting magefile}
752 #
753 # MAGE_TREE_DEST target destination of the generated tree
754 # REGEN_MAGE_TREE set to 'true' to enable this
755 #
756 # gets called with build_mage_script target
757 build_mage_script()
758 {
759 local magefile
760 local dest
761 local target
762 local split_pkg_base
763 local sym
764 local depname
765
766 # if MAGE_TREE_DEST not set use BUILDDIR
767 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
768
769 # determinate which suffix this mage file should get, if any
770 [[ $1 = --target ]] && shift && target="-$1"
771
772 # mark package as splitpackage
773 [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
774
775 # name of magefile
776 magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
777
778 # destination to magefile
779 dest="${MAGE_TREE_DEST}/${PCAT}/${PNAME}${target}/${magefile}"
780
781 # show what we are doing
782 echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
783 echo "${dest}"
784
785 install -d "$(dirname ${dest})"
786 # now build the mage file
787 > ${dest}
788
789 # pgkname and state
790 echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}$(print_distrotag)-${PBUILD}\"" >> ${dest}
791 echo "STATE=\"${STATE}\"" >> ${dest}
792
793 # description and homepage
794 echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
795 echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
796
797 # license information
798 echo "LICENSE=\"${LICENSE}\"" >> ${dest}
799
800 # special tags and vars
801 echo "PKGTYPE=\"${PKGTYPE}\"" >> ${dest}
802
803 # echo MAGE_TARGETS ## note -target is needed !
804 echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
805
806 # split package base
807 echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
808
809 # add special vars
810 if [ -n "${SPECIAL_VARS}" ]
811 then
812 local i
813 for i in ${SPECIAL_VARS}
814 do
815 # being tricky here :)
816 echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
817 done
818 fi
819
820 # add at least all includes
821 if [ -n "${INHERITS}" ]
822 then
823 echo -n "minclude" >> ${dest}
824 local i
825 for i in ${INHERITS}
826 do
827 echo -n " ${i}" >> ${dest}
828 done
829 # a CRLF is needed here!
830 echo >> ${dest}
831 fi
832
833 # deps and provides
834 echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
835 echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
836 echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
837
838 # add special functions
839 if [ -n "${SPECIAL_FUNCTIONS}" ]
840 then
841 local i
842 for i in ${SPECIAL_FUNCTIONS}
843 do
844 # add to mage (quotes needed !)
845 typeset -f "${i}" >> ${dest}
846 # unset to be safe (quotes needed !)
847 #unset "${i}" <-- later to get every target built
848 done
849 fi
850
851 # pre|post-install|removes
852 typeset -f preinstall >> ${dest}
853 typeset -f postinstall >> ${dest}
854 typeset -f preremove >> ${dest}
855 typeset -f postremove >> ${dest}
856 }
857
858 regen_mage_tree()
859 {
860 local subpackage
861
862 # build them only if requested
863 if mqueryfeature regentree
864 then
865 # run it without targets
866 if [[ -n ${MAGE_TARGETS} ]]
867 then
868 # build for each target a mage file
869 # run it with several targets
870 echo
871 for subpackage in ${MAGE_TARGETS}
872 do
873 build_mage_script --target "${subpackage}"
874 done
875 echo
876
877 # run it for splitpackages
878 elif [[ -n ${SPLIT_PACKAGES} ]]
879 then
880 local split_pkg_base="${PNAME}"
881 # save smage environment
882 split_save_variables
883 # build for each subpackage a mage file
884 # run it with several targets
885 echo
886 for subpackage in ${SPLIT_PACKAGES}
887 do
888 # get the right variables for the split
889 export PNAME="${subpackage}"
890 split_info_${subpackage}
891 # fix PCATEGORIE -> PCAT
892 if [[ ! -z ${PCATEGORIE} ]]
893 then
894 PCAT="${PCATEGORIE}"
895 unset PCATEGORIE
896 fi
897 # get the preinstall etc
898 split_export_inherits ${subpackage}
899 build_mage_script --split-pkg-base "${split_pkg_base}"
900 # delete split preinstall etc
901 split_delete_inherits ${subpackage}
902 # restore smage environment
903 split_restore_variables
904 done
905 echo
906 # unset all saved smage variables
907 split_unset_variables
908
909 else
910 echo
911 build_mage_script
912 echo
913 fi
914 fi
915
916 # now unset all uneeded vars to be safe
917 # unset PKGNAME <-- don't do that; smage needs this var
918 # unset to be safe (quotes needed !)
919 # for i in ${SPECIAL_FUNCTIONS}
920 # do
921 # unset "${i}"
922 # done
923 unset SPECIAL_FUNCTIONS
924 # for i in ${SPECIAL_VARS}
925 # do
926 # unset "${i}"
927 # done
928 unset SPECIAL_VARS
929 unset STATE
930 unset DESCRIPTION
931 unset HOMEPAGE
932 # unset PKGTYPE <-- don't do that either; smage needs this var
933 unset INHERITS
934 unset DEPEND
935 unset SDEPEND
936 unset PROVIDE
937 unset preinstall
938 unset postinstall
939 unset preremove
940 unset postremove
941 }
942
943 split_save_variables()
944 {
945 export SAVED_PNAME="${PNAME}"
946 export SAVED_PVER="${PVER}"
947 export SAVED_PBUILD="${PBUILD}"
948 export SAVED_PCAT="${PCAT}"
949 export SAVED_DESCRIPTION="${DESCRIPTION}"
950 export SAVED_HOMEPAGE="${HOMEPAGE}"
951 export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
952 export SAVED_STATE="${STATE}"
953 export SAVED_PKGTYPE="${PKGTYPE}"
954 export SAVED_INHERITS="${INHERITS}"
955 export SAVED_DEPEND="${DEPEND}"
956 export SAVED_SDEPEND="${SDEPEND}"
957 export SAVED_PROVIDE="${PROVIDE}"
958 export SAVED_PKGTYPE="${PKGTYPE}"
959
960 # special handling needed for mage features
961 # pkgbuild
962 mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
963 mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
964 # strip
965 mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
966 mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
967 # libtool
968 mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
969 mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
970 # compressdoc
971 mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
972 mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
973
974 # bindir too
975 export SAVED_BINDIR="${BINDIR}"
976
977 # export the SPLIT_PACKAGE_BASE
978 export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
979
980 # functions
981 if [[ ! -z $(typeset -f preinstall) ]]
982 then
983 # rename the old one
984 local saved_preinstall
985 saved_preinstall=SAVED_$(typeset -f preinstall)
986 eval "${saved_preinstall}"
987 export -f SAVED_preinstall
988 fi
989
990 if [[ ! -z $(typeset -f postinstall) ]]
991 then
992 # rename the old one
993 local saved_postinstall
994 saved_postinstall=SAVED_$(typeset -f postinstall)
995 eval "${saved_postinstall}"
996 export -f SAVED_postinstall
997 fi
998
999 if [[ ! -z $(typeset -f preremove) ]]
1000 then
1001 # rename the old one
1002 local saved_preremove
1003 saved_preremove=SAVED_$(typeset -f preremove)
1004 eval "${saved_preremove}"
1005 export -f SAVED_preremove
1006 fi
1007
1008 if [[ ! -z $(typeset -f postremove) ]]
1009 then
1010 # rename the old one
1011 local saved_postremove
1012 saved_postremove=SAVED_$(typeset -f postremove)
1013 eval "${saved_postremove}"
1014 export -f SAVED_postremove
1015 fi
1016 }
1017
1018 split_restore_variables()
1019 {
1020 export PNAME="${SAVED_PNAME}"
1021 export PVER="${SAVED_PVER}"
1022 export PBUILD="${SAVED_PBUILD}"
1023 export PCAT="${SAVED_PCAT}"
1024 export DESCRIPTION="${SAVED_DESCRIPTION}"
1025 export HOMEPAGE="${SAVED_HOMEPAGE}"
1026 export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
1027 export STATE="${SAVED_STATE}"
1028 export PKGTYPE="${SAVED_PKGTYPE}"
1029 export INHERITS="${SAVED_INHERITS}"
1030 export DEPEND="${SAVED_DEPEND}"
1031 export SDEPEND="${SAVED_SDEPEND}"
1032 export PROVIDE="${SAVED_PROVIDE}"
1033 export PKGTYPE="${SAVED_PKGTYPE}"
1034
1035 # special handling needed for mage features
1036 # pkgbuild
1037 FVERBOSE=off msetfeature "${SAVED_FEATURE_PKGBUILD}"
1038 # strip
1039 FVERBOSE=off msetfeature "${SAVED_FEATURE_STRIP}"
1040 # libtool
1041 FVERBOSE=off msetfeature "${SAVED_FEATURE_LIBTOOL}"
1042 # compressdoc
1043 FVERBOSE=off msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
1044
1045 # bindir too
1046 export BINDIR="${SAVED_BINDIR}"
1047
1048 # functions
1049 if [[ ! -z $(typeset -f SAVED_preinstall) ]]
1050 then
1051 # rename the old one
1052 local saved_preinstall
1053 saved_preinstall=$(typeset -f SAVED_preinstall)
1054 eval "${saved_preinstall/SAVED_/}"
1055 export -f preinstall
1056 fi
1057
1058 if [[ ! -z $(typeset -f SAVED_postinstall) ]]
1059 then
1060 # rename the old one
1061 local saved_postinstall
1062 saved_postinstall=$(typeset -f SAVED_postinstall)
1063 eval "${saved_postinstall/SAVED_/}"
1064 export -f postinstall
1065 fi
1066
1067 if [[ ! -z $(typeset -f SAVED_preremove) ]]
1068 then
1069 # rename the old one
1070 local saved_preremove
1071 saved_preremove=$(typeset -f SAVED_preremove)
1072 eval "${saved_preremove/SAVED_/}"
1073 export -f preremove
1074 fi
1075
1076 if [[ ! -z $(typeset -f SAVED_postremove) ]]
1077 then
1078 # rename the old one
1079 local saved_postremove
1080 saved_postremove=$(typeset -f SAVED_postremove)
1081 eval "${saved_postremove/SAVED_/}"
1082 export -f postremove
1083 fi
1084 }
1085
1086 split_unset_variables()
1087 {
1088 # unset saved vars; not needed anymore
1089 unset SAVED_PNAME
1090 unset SAVED_PVER
1091 unset SAVED_PBUILD
1092 unset SAVED_PCAT
1093 unset SAVED_DESCRIPTION
1094 unset SAVED_HOMEPAGE
1095 unset SAVED_SPECIAL_VARS
1096 unset SAVED_STATE
1097 unset SAVED_PKGTYPE
1098 unset SAVED_INHERITS
1099 unset SAVED_DEPEND
1100 unset SAVED_SDEPEND
1101 unset SAVED_PROVIDE
1102 unset SAVED_BINDIR
1103 unset SAVED_PKGTYPE
1104 unset SAVED_FEATURE_PKGBUILD
1105 unset SAVED_FEATURE_STRIP
1106 unset SAVED_FEATURE_LIBTOOL
1107 unset SAVED_FEATURE_COMPRESSDOC
1108 unset SPLIT_PACKAGE_BASE
1109 unset -f SAVED_preinstall
1110 unset -f SAVED_postinstall
1111 unset -f SAVED_preremove
1112 unset -f SAVED_postremove
1113 }
1114
1115 split_export_inherits()
1116 {
1117 local subpackage="$1"
1118 local func
1119 local newfunc
1120
1121 for func in preinstall postinstall preremove postremove
1122 do
1123 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1124 then
1125 newfunc=$(typeset -f ${func}_${subpackage})
1126 newfunc="${newfunc/_${subpackage} (/ (}"
1127 eval "${newfunc}"
1128 fi
1129 done
1130 }
1131
1132 split_delete_inherits()
1133 {
1134 local subpackage="$1"
1135 local func
1136
1137 for func in preinstall postinstall preremove postremove
1138 do
1139 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1140 then
1141 unset -f ${func}
1142 fi
1143 done
1144 }
1145
1146 export_inherits()
1147 {
1148 local include="$1"
1149 shift
1150
1151 while [ "$1" ]
1152 do
1153 local functions="$1"
1154
1155 # sanity checks
1156 [ -z "${include}" ] && die "export_inherits(): \$include not given."
1157 [ -z "${functions}" ] && die "export_inherits(): \$functions not given."
1158
1159 eval "${functions}() { ${include}_${functions} ; }"
1160
1161 # debug
1162 [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"
1163
1164 shift
1165 done
1166 }
1167
1168 generate_package_md5sum()
1169 {
1170 local dest
1171 local pcat
1172 local pname
1173 local pver
1174 local pbuild
1175 local parch
1176 local target
1177 local pkgname
1178
1179 # very basic getops
1180 for i in $*
1181 do
1182 case $1 in
1183 --pcat|-c) shift; pcat="$1" ;;
1184 --pname|-n) shift; pname="$1" ;;
1185 --pver|-v) shift; pver="$1" ;;
1186 --pbuild|-b) shift; pbuild="$1" ;;
1187 --parch|a) shift; parch="$1" ;;
1188 --target|t) shift; target="$1" ;;
1189 esac
1190 shift
1191 done
1192
1193 # sanity checks; abort if not given
1194 [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."
1195 [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."
1196 [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."
1197 [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."
1198 [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."
1199
1200 # check needed global vars
1201 [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."
1202 [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."
1203
1204 # fix target as it may be empty !
1205 [ -n "${target}" ] && target="-${target}"
1206
1207 # build pkgname
1208 pkgname="${pname}${target}-${pver}-${parch}$(print_distrotag)-${pbuild}"
1209
1210 # build pkg-md5-sum only if requested
1211 if mqueryfeature regentree
1212 then
1213 echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1214
1215 # abort if not exist
1216 if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]
1217 then
1218 echo -e "${COLRED}! exists${COLDEFAULT}"
1219 return 0
1220 fi
1221
1222 # if MAGE_TREE_DEST not set use BUILDDIR
1223 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1224
1225 # setup md5 dir
1226 dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
1227 install -d ${dest}
1228
1229 # gen md5sum
1230 ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \
1231 > ${dest}/${pkgname}.md5
1232 echo -e "${COLGREEN}done${COLDEFAULT}"
1233 fi
1234 }
1235
1236 source_pkg_build()
1237 {
1238 if [[ ${PKGTYPE} = virtual ]]
1239 then
1240 echo "Virtual package detected; src-pkg-tarball not necessary ..."
1241 return 0
1242 fi
1243
1244 if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
1245 then
1246 echo "No SRC_URI defined; src-pkg-tarball not necessary ..."
1247 return 0
1248 fi
1249
1250 [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
1251
1252 echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"
1253
1254 # include the smage2 file
1255 cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}
1256
1257 ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )
1258 [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
1259 mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
1260
1261 echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}\n"
1262 }
1263
1264 step_by_step()
1265 {
1266 if mqueryfeature stepbystep
1267 then
1268 echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1269 echo "Press [enter] to continue"
1270 read
1271 fi
1272 }
1273
1274 resume_stamp()
1275 {
1276 local step="$1"
1277 [[ ! -d ${BUILDDIR}/.stamps ]] && install -d ${BUILDDIR}/.stamps
1278 touch ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step}
1279 }
1280
1281 run_resume()
1282 {
1283 local step="$1"
1284
1285 if mqueryfeature "resume" && [[ -f ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step} ]]
1286 then
1287 echo -e "${COLMAGENTA}${step} already processed; doing nothing${COLDEFAULT}"
1288 return 0
1289 else
1290 return 1
1291 fi
1292 }